const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const votes = sequelize.define(
    'votes',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

target_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"problem_report",


"solution_proposal"

        ],

      },

value: {
        type: DataTypes.ENUM,
      
      

        values: [

"up",


"down"

        ],

      },

voted_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  votes.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.votes.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.votes.belongsTo(db.problem_reports, {
      as: 'problem_report',
      foreignKey: {
        name: 'problem_reportId',
      },
      constraints: false,
    });

    db.votes.belongsTo(db.solution_proposals, {
      as: 'solution_proposal',
      foreignKey: {
        name: 'solution_proposalId',
      },
      constraints: false,
    });

    db.votes.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.votes.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.votes.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return votes;
};


